#pragma once


#include "APIEnvir.h"
#include "ACAPinc.h"
#include "APICommon.h"


#include "DG.h"
#include "DGModule.hpp"


const GS::Guid SamplePaletteGuid{ "C67E8137-A2AC-42FD-BDE6-413F509731B8" };
const Int32    SamplePaletteGuidRefId = (Int32)GS::GenerateHashValue(SamplePaletteGuid);

class SamplePalette 
	: public DG::Palette
	, public DG::PanelObserver
	, public DG::ListBoxObserver
{

public:
	static SamplePalette& GetInstance();
	static bool HasInstance();
	static void CreateInstance();

	void ShowPalette();
	void HidePalette();

	void ClosePalette();
	bool IsPaletteVisible();

	void DeleteUserData();
	void GetElementList();

	virtual	void PanelCloseRequested(const DG::PanelCloseRequestEvent& ev, bool* accepted) override;
	virtual void PanelOpened(const DG::PanelOpenEvent& ev) override;
	virtual void ListBoxClicked(const DG::ListBoxClickEvent& ev) override;

protected:
	SamplePalette();
	virtual ~SamplePalette();


private:
	static SamplePalette* instance;

	enum
	{
		listBoxID = 1,
	};

	DG::SingleSelListBox listBox;
};